/*
        HiScores (for games) menegment (with simple en/decoding routines).
        At the end of file is a small example on how to use.
	UNIX version
 */


#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#define MAX_ENTRYS 10
class T_HiScores {
        public:
                 class T_Entry {
                   public:
                       char Name[20];
                       long Score;
                       int  FilledLines;
                       int  FirstLevel;
                       int  LastLevel;
                 };
        T_Entry Entrys[MAX_ENTRYS+1];
        char    *Array;
        char    Filename[80];


/*long filesize(char *Name)
{
   FILE *stream;
   long curpos, length;

   stream = fopen(Name, "r+w+");
   fprintf(stream, "This is a test");


   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);

   fclose(stream);

   return length;
} */



void Init(char *Name)
{
     int handle;


     strcpy(Filename, Name);
     memset(Entrys, 0, sizeof(Entrys));


/*    _fmode = O_BINARY;
*/
     if ((handle = open(Filename, O_RDONLY /* | O_BINARY*/)) == -1)
        handle=creat(Filename, S_IREAD | S_IWRITE);

//     if (lseek(handle, 0L, SEEK_END)!=sizeof(Entrys)-sizeof(T_Entry)) return;
//     if (filesize(Filename)!=sizeof(Entrys)-sizeof(T_Entry)) return;
//     lseek(handle, 0L, SEEK_SET);



     int bytes;

     bytes=read(handle, Entrys, sizeof(Entrys)-sizeof(T_Entry));
     if (bytes!=sizeof(Entrys)-sizeof(T_Entry))
     {
	memset(Entrys, 0, sizeof(Entrys));
	close(handle);
	return;
     };
     
     close(handle);
     Decode();

     Sort();
};

void Sort()
{
     T_Entry Temp;
     for (int h=0; h<MAX_ENTRYS; h++)
     for (int i=0; i<=MAX_ENTRYS; i++)
     {
         for (int j=i+1; j<=MAX_ENTRYS; j++)
         {
             if (Entrys[i].Score<Entrys[j].Score)
             {
                memcpy(&Temp, &Entrys[i], sizeof(Temp));
                memcpy(&Entrys[i], &Entrys[j], sizeof(Temp));
                memcpy(&Entrys[j], &Temp, sizeof(Temp));
                break;
             };
         };
     };
};


void Get(int  Which,
         char *Name,
         long *Score,
         int  *FilledLines,
         int  *FirstLevel,
         int  *LastLevel)
{
         if (Name!=NULL)                   strcpy(Name, Entrys[Which].Name);
         if (Score!=NULL)       (*Score)=Entrys[Which].Score;
         if (FilledLines!=NULL) (*FilledLines)=Entrys[Which].FilledLines;
         if (FirstLevel!=NULL)  (*FirstLevel)=Entrys[Which].FirstLevel;
         if (LastLevel!=NULL)   (*LastLevel)=Entrys[Which].LastLevel;
};


void Add(char *Name,
         long Score,
         int  FilledLines,
         int  FirstLevel,
         int  LastLevel)
{
     strcpy(Entrys[MAX_ENTRYS].Name, Name);
     Entrys[MAX_ENTRYS].Score=Score;
     Entrys[MAX_ENTRYS].FilledLines=FilledLines;
     Entrys[MAX_ENTRYS].FirstLevel=FirstLevel;
     Entrys[MAX_ENTRYS].LastLevel=LastLevel;

     Sort();
};

void Update()
{
     int handle;

     Sort();

     Encode();
/*     _fmode = O_BINARY; */ 
/* change the default file mode from text to binary */
     handle = creat(Filename, S_IREAD | S_IWRITE);

     write(handle, Entrys, sizeof(Entrys)-sizeof(T_Entry));

     close(handle);
     Decode();
}

                   private:

void Encode()
{
     Array=(char *) Entrys;
     for (int a=0; a<sizeof(Entrys); a++)
        Array[a]=Array[a]+79;
};

void Decode()
{
     Array=(char *) Entrys;
     for (int a=0; a<sizeof(Entrys); a++)
        Array[a]=Array[a]-79;
};
};

